function [Y_resu, Y_conf] = gdsvm_predict_ecconomy3(X_test, bias, idx_feat, prd_filename, use_written)
%[Y_resu, Y_conf] = gdsvm_predict_ecconomy3(X_test, param, idx_feat, prd_filename, use_written)
%
% gd  updated 9.4.2004
%
% if prd_filename appears, and use_written = 1, 
% then the data written already to prd_filename is reused for training

working_dir = 'C:\temp\';
svmlight_dir = 'C:\svm_light\';

if nargin == 3
    use_written = 0;
    prd_filename = [working_dir 'prd_svm.txt'];
elseif nargin == 4
    use_written = 0;
end

out_filename = [working_dir 'svm_out.txt'];
model_filename = [working_dir 'model'];

if use_written == 0
    fid1 = fopen(prd_filename,'w');
    Y = zeros(size(X_test,1),1);
    write_examples(X_test(:,idx_feat),Y, fid1);
    fclose(fid1);
    pause(0.1);
end

dos([svmlight_dir 'svm_classify ' prd_filename ' ' model_filename ' ' out_filename]);
Y_score = load(out_filename);
if ~isempty(bias)
    Y_score = Y_score - bias;
end

Y_resu=sign(Y_score);
%the resu for each example must have either -1 or 1.  
I0 = find(Y_resu == 0);
if ~isempty(I0)
    Y_resu(I0) = 1;
end
Y_conf=abs(Y_score);

return



    