function [Y_resu, Y_conf]=mfold_cv3(X_train, Y_train, X_test, svm_params, mfold, use_written);
% calculate the correct trhreshold using categorization of test examples 
% before doing the mfold

if size(X_train,1) ~= size(Y_train,1)
    error('sizes of X_train and Y_train not compatible')
end

idx = 1:size(X_train,2);

train_filename  = ['C:\nips03workshop\select_kit18_2\temp\trn_svm_all.txt'];
prd_filename  = ['C:\nips03workshop\select_kit18_2\temp\prd_svm_all.txt'];    
[param, idx_out] = gdsvm_train_ecconomy(X_train, Y_train, idx, svm_params, train_filename, use_written);
%calculate the raw outputs on test set
[Y_resu, Y_conf] = gdsvm_predict_ecconomy3(X_test, [], idx, prd_filename, use_written);
bias = prctile(Y_resu.*Y_conf,param*100);


n_all = size(X_train,1);
all_ind = 1:n_all;
boundaries = round([0:n_all/mfold:n_all]);

Y_resu = zeros(size(Y_train));
Y_conf = zeros(size(Y_train));
for m = 1:mfold
    btst = boundaries(m)+1:boundaries(m+1);
    btrn = setdiff(all_ind, btst);
    train_filename  = ['C:\nips03workshop\select_kit18_2\temp\trn_svm_' num2str(m) '.txt'];
    prd_filename  = ['C:\nips03workshop\select_kit18_2\temp\prd_svm_' num2str(m) '.txt'];    
    [param, idx_out] = gdsvm_train_ecconomy(X_train(btrn,:), Y_train(btrn), idx, svm_params, train_filename, use_written);
    [Y_resu_m, Y_conf_m] = gdsvm_predict_ecconomy3(X_train(btst,:), bias, idx, prd_filename, use_written);
    Y_resu(btst) = Y_resu_m;
    Y_conf(btst) = Y_conf_m;
end

return