function [Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize_data(Xtrain, Xvalid, Xtest) 
%[Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize_data(Xtrain, Xvalid, Xtest) 
% Normalize the training validation and test data 
%[Xtrain_norm, Xtest_norm] = normalize_data(Xtrain, Xtest) 
% Normalize the training and test data only
% by shifting the mean of Xtrain to zero and rescaling the stdev to one. 

% gideon dror,  jan 2004, adapted from:
% Isabelle Guyon, last change Oct 2003, isabelle@clopinet.com

Mean = mean(Xtrain);
Stdev = std(Xtrain);
fudge=median(Stdev);
Stdev=Stdev+fudge;

[p,n]=size(Xtrain);
M=repmat(Mean,p,1);
S=repmat(Stdev, p, 1);
Xtrain_norm=(Xtrain-M)./S;
if nargin >1
   [p,n]=size(Xvalid);
   M=repmat(Mean,p,1);
   S=repmat(Stdev, p, 1);
   Xvalid_norm=(Xvalid-M)./S;
end
if nargin >2
   [p,n]=size(Xtest);
   M=repmat(Mean,p,1);
   S=repmat(Stdev, p, 1);
   Xtest_norm=(Xtest-M)./S;
end

return