function [Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize2_data(Xtrain, Xvalid, Xtest) 
%[Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize2_data(Xtrain, Xvalid, Xtest) 
% Normalize the training validation and test data 
%[Xtrain_norm, Xtest_norm] = normalize2_data(Xtrain, Xtest) 
% Normalize the training and test data only
% scale all vectors to unit length (l2 norm)

% gideon dror,  jan 2004, adapted from:
% Isabelle Guyon, last change Oct 2003, isabelle@clopinet.com

norm = sqrt(sum(Xtrain.^2,2));
norm = norm + eps;
[p,n]=size(Xtrain);
Xtrain_norm=Xtrain./repmat(norm,1,n);

if nargin >1
   norm = sqrt(sum(Xvalid.^2,2));
   norm = norm + eps;
   [p,n]=size(Xvalid);
   Xvalid_norm=Xvalid./repmat(norm,1,n);
end
if nargin >2
   norm = sqrt(sum(Xtest.^2,2));
   norm = norm + eps;
   [p,n]=size(Xtest);
   Xtest_norm=Xtest./repmat(norm,1,n);
end

return