function [Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize3_data(Xtrain, Xvalid, Xtest) 
%[Xtrain_norm, Xvalid_norm, Xtest_norm] = normalize3_data(Xtrain, Xvalid, Xtest) 
% Normalize the training validation and test data 
%[Xtrain_norm, Xtest_norm] = normalize2_data(Xtrain, Xtest) 
% Normalize the training and test data only
% scale all vectors to such that mean length is 1
% gideon dror,  jan 2004, adapted from:
% Isabelle Guyon, last change Oct 2003, isabelle@clopinet.com

norm = sqrt(sum(Xtrain.^2,2));
scale = mean(norm);
Xtrain_norm=Xtrain/scale;

if nargin >1
   [p,n]=size(Xvalid);
   Xvalid_norm=Xvalid/scale;
end
if nargin >2
   [p,n]=size(Xtest);
   Xtest_norm=Xtest/scale;
end

return