%svm_batch_mfold_ver3
% perform mfold cross validation
mfold = 10;  

normalize_prms = [1 2 3];
c_prms = [0.1 1 10]; 
sv_prms = {'-t 0 ', '-t 1 -d 2 ',  '-t 1 -d 3', '-t 2 -g 0.125' , '-t 2 -g 0.25', '-t 2 -g 0.5', '-t 2 -g 1'  '-t 2 -g 2'};
datasets={'arcene', 'dexter', 'dorothea', 'gisette', 'madelon'};
dates = {'dec1','dec8'};


i0 = 1; j0 = 1; k0 = 1; l0 = 1; m0 = 1; n0 = 1;

where_my_data_is='C:/nips03workshop/';            % This is the path to your data and results are
data_dir=[where_my_data_is 'data'];
labels_dir = 'g:\nips03workshop\paper\select_kit\matlab\';
log_file = 'g:\nips03workshop\paper\select_kit\matlab\log_mfold.txt';
res_mfold_file = 'g:\nips03workshop\paper\select_kit\matlab\res_mfold_ver3.txt';   % each set of (data_name, dt, featureset) is written there on completion 

tic
for i = i0:length(datasets)
   data_name = datasets{i};
   
   load([data_dir '/' data_name]); % this would input all patterns, as well as training set targets
   %Y_valid = read_labels([labels_dir '/' data_name '_valid.labels']);
   %Y_test = read_labels([labels_dir '/' data_name '_test.labels']);
      
   %for j =j0:length(dates)
   for j =j0:1
      dt = dates{j};
      for k	= k0:5
         fn = best_feat(dt, data_name, k);  % this just gives the code
         % full names are  of the form 'dec1_aIiushFx_dorothea.feat';
         feat_fn = [labels_dir '/' dt '_' fn '_' data_name '.feat'];
         idx = load(feat_fn);
 
 		 for n = n0:length(normalize_prms)
			normalize = normalize_prms(n);		        
			switch normalize 
            case 0,
                X_train_nrm = X_train(:,idx);
                X_valid_nrm = X_valid(:,idx);
                X_test_nrm = X_test(:,idx);
            case 1
                [X_train_nrm, X_valid_nrm, X_test_nrm] = normalize1_data(X_train(:,idx), X_valid(:,idx),X_test(:,idx));
            case 2
                [X_train_nrm, X_valid_nrm, X_test_nrm] = normalize2_data(X_train(:,idx), X_valid(:,idx),X_test(:,idx));
            case 3
                [X_train_nrm, X_valid_nrm, X_test_nrm] = normalize3_data(X_train(:,idx), X_valid(:,idx),X_test(:,idx));
            end  %if strcmp(data_name,'madelon')
         
			for l = l0:length(sv_prms)            
				for m = m0:length(c_prms)
                    logstr = [sprintf('%d %d %d %d %d %d ',i,j,k,l,m,n) '  ' datestr(now)];
                    put_line(log_file, logstr);
					svm_params = [sv_prms{l} ' -c ' num2str(c_prms(m))];
                    
                    use_written = (l > l0);
                    
					if dt == 'dec1'              
					   [Y_resu, Y_conf]=mfold_cv3(X_train_nrm, Y_train, X_test_nrm, svm_params, mfold, use_written);
                              
					   berr_mfold = balanced_errate(Y_resu, Y_train);
					   auc_mfold = auc(Y_resu.*Y_conf, Y_train);
					   res = sprintf('%d %d %d %d %d %d %6.4f %6.4f',i,j,k,l,m,n,berr_mfold,auc_mfold);
					   put_line(res_mfold_file,res);
                       put_line(res_mfold_h,res);
               		else               
					   [Y_resu, Y_conf]=mfold_cv3([X_train_nrm;X_valid_nrm], [Y_train;Y_valid], X_test_nrm, svm_params, mfold, use_written);
               
					   berr_mfold = balanced_errate(Y_resu, [Y_train;Y_valid]);
					   auc_mfold = auc(Y_resu.*Y_conf, [Y_train;Y_valid]);
					   res = sprintf('%d %d %d %d %d %d %6.4f %6.4f',i,j,k,l,m,n,berr_mfold,auc_mfold);
					   put_line(res_mfold_file,res);
					end   %if dt == 'dec1'
				end   %for m = 1:length(c_prms)
                m0 = 1;
			end    %for l = 1:length(sv_prms)
            l0 = 1;
		end  %for n = 1:length((normalize_prms)
        n0 = 1;
      end    %for k	= 1:5
      k0 = 1;
   end   %for j =1:length(dates)
   j0 = 1;
end   %for i = 1:length(datasets)

toc